# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`postgresql_userconfig`](#postgresql_userconfig): main class to generate postgres passfiles

### Defined types

* [`postgresql_userconfig::passfile`](#postgresql_userconfigpassfile): initialize a passfile
* [`postgresql_userconfig::passfile_entry`](#postgresql_userconfigpassfile_entry): add an entry (line) in one ore more pgpass files

## Classes

### `postgresql_userconfig`

main class to generate postgres passfiles

#### Examples

##### 

```puppet
include postgresql_passfile
```

#### Parameters

The following parameters are available in the `postgresql_userconfig` class.

##### `passfiles`

Data type: `Hash`

Hash to create the files, see postgresql_userconfig::passfile
for keys to use.
in hiera this parameter is hash merged

Default value: `{}`

##### `passfiles_defaults`

Data type: `Hash`

use this if you want any defaults changed for the files.

Default value: `{}`

##### `passfile_entries`

Data type: `Hash`

Hash to create file entries, see postgresql_userconfig::passfile_entry
for keys to use.
in hiera this parameter is hash merged

Default value: `{}`

##### `passfile_entries_defaults`

Data type: `Hash`

use this if you want any defaults changed for the entries.

Default value: `{}`

## Defined types

### `postgresql_userconfig::passfile`

initialize a passfile

#### Examples

##### 

```puppet
postgresql_userconfig::passfile { 'namevar': }
```

#### Parameters

The following parameters are available in the `postgresql_userconfig::passfile` defined type.

##### `filename`

Data type: `String`

filename to write

Default value: `'.pgpass'`

##### `filepath`

Data type: `String`

the path to use for the file to write,
normaly the homedirectory of the user.
but puppet cannot (yet ?) detect your'e home,
so we make this a parameter

##### `owner`

Data type: `String`

owner of the file (defaults to the title)

Default value: `$title`

##### `group`

Data type: `Optional[String]`

group of the file.

Default value: ``undef``

##### `mode`

Data type: `String`

the mode of the file

Default value: `'0600'`

##### `filename`

the path and name of the file to create.

Default value: `'.pgpass'`

### `postgresql_userconfig::passfile_entry`

lets you define a line entry in the pgpass file
for simplification, you can define multiple targets.

#### Examples

##### 

```puppet
postgresql_userconfig::passfile_entry { 'namevar': }
```

#### Parameters

The following parameters are available in the `postgresql_userconfig::passfile_entry` defined type.

##### `targets`

Data type: `Variant[String, Array]`

the title of the target passfile. this can also
be an array, if you like to add a database to several
pgpass files.

Default value: `[]`

##### `comment`

Data type: `Optional[String]`

a simple comment to add to the file prior to the entry

Default value: ``undef``

##### `hostname`

Data type: `String`

the hostname entry

Default value: `'*'`

##### `port`

Data type: `String`

the port entry

Default value: `'5432'`

##### `database`

Data type: `String`

the database entry

Default value: `$title`

##### `username`

Data type: `String`

the username entry

Default value: `'*'`

##### `password`

Data type: `Optional[String]`

the password entry

Default value: ``undef``

##### `order`

Data type: `String`

the order in the file

Default value: `'100'`

